""" list_comprehension_sprite.py """

import math
import pygame
from pygame.locals import *
import sys

pygame.init()
SCR_RECT = Rect(0,0,400,300)
SURFACE = pygame.display.set_mode(SCR_RECT.size)
FPSCLOCK = pygame.time.Clock()

pygame.display.set_caption("Sunflowers")

class MySprite(pygame.sprite.Sprite):
    """ スプライト定義 """
    def __init__(self, filename, x=0, y=0):
        pygame.sprite.Sprite.__init__(self)
        self.image = pygame.image.load(filename)
        self.width = self.image.get_width()
        self.height = self.image.get_height()
        self.x = x
        self.y = y
        self.rect = Rect(self.x, self.y, self.width, self.height)
    #スプライト表示
    def locate(self, x = 9999, y = 9999):
        if x < 9999:
            self.x = x
        if y < 9999:
            self.y = y
        self.rect = Rect(self.x, self.y, self.width, self.height)

def main():
    """ メインルーチン """

    #三角関数結果をリスト化(内包表記)
    circle_x = [math.cos(math.pi/180*i) for i in range(360)]
    circle_y = [math.sin(math.pi/180*i) for i in range(360)]

    #スプライトグループ作成
    sprites = pygame.sprite.Group()

    #ひまわりスプライト定義(リスト)
    sunflowers = []
    for i in range(10): 
        sunflowers.append(0)
        sunflowers[i] = MySprite("sunflowers.gif", circle_x[i*36]*100+200,circle_y[i*36]*100+200)
        sprites.add(sunflowers[i])

    #変数初期設定
    circle_counter = 0
    a = 0
        
    while True:

        #ウインドウ閉じるボタン
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()

        #画面塗りつぶし              
        SURFACE.fill((0,0,0))

        #角度カウンター
        circle_counter += 1
        if circle_counter >= 360:
            circle_counter = 0

        #ひまわり座標計算
        for i in range(10):
            a = circle_counter + i * 36
            if a >= 360:
                a -= 360
            sunflowers[i].locate(circle_x[a]*100+175,circle_y[a]*110+125)

        #スプライトグループ表示
        sprites.draw(SURFACE)

        #画面アップデート
        pygame.display.update()
        FPSCLOCK.tick(100)

if __name__ == '__main__':
    main()
